From 6a3036f898b050d5e71e70eaceccd63003aa6444 Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Fri, 6 Feb 2026 13:53:07 +0700
Subject: [PATCH v9 17/26] Adding ability to switch data init between single
 and multiple transactions

---
 src/bin/pgbench/pgbench.c                    | 192 +++++++++----------
 src/bin/pgbench/t/001_pgbench_with_server.pl |  93 ++++++++-
 2 files changed, 173 insertions(+), 112 deletions(-)

diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index 466d9023d72..af71e358e71 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -159,9 +159,8 @@ typedef struct socket_set
 
 /********************************************************************
  * some configurable parameters */
-
-#define DEFAULT_INIT_STEPS "dtgvp"	/* default -I setting */
-#define ALL_INIT_STEPS "dtgCGiIvpf"	/* all possible steps */
+#define DEFAULT_INIT_STEPS "dtgvp"		/* default -I setting */
+#define ALL_INIT_STEPS "dtgMScGUvpf"	/* all possible steps */
 
 #define LOG_STEP_SECONDS	5	/* seconds between log messages */
 #define DEFAULT_NXACTS		10	/* default nxacts */
@@ -171,14 +170,17 @@ typedef struct socket_set
 #define MIN_ZIPFIAN_PARAM		1.001	/* minimum parameter for zipfian */
 #define MAX_ZIPFIAN_PARAM		1000.0	/* maximum parameter for zipfian */
 
-/* original single transaction server-side method */
-#define GEN_TYPE_INSERT_ORIGINAL	'G'	/* use INSERT .. SELECT generate_series to generate data */
-/* 'one transaction per scale' server-side methods */
-#define GEN_TYPE_INSERT_SERIES		'i'	/* use INSERT .. SELECT generate_series to generate data */
-#define GEN_TYPE_INSERT_UNNEST  	'I'	/* use INSERT .. SELECT unnest to generate data */
-#define GEN_TYPE_COPY_ORIGINAL		'g' /* use COPY .. FROM STDIN .. TEXT to generate data */
-#define GEN_TYPE_COPY_BINARY		'C' /* use COPY .. FROM STDIN .. BINARY to generate data */
-
+/* server-side methods to generate data */
+#define INIT_STEP_GEN_TYPE_INSERT_SERIES	'G'	/* use INSERT .. SELECT generate_series to generate data */
+#define INIT_STEP_GEN_TYPE_INSERT_UNNEST	'U'	/* use INSERT .. SELECT unnest to generate data */
+/* client-side methods to generate data */
+#define INIT_STEP_GEN_TYPE_COPY_TEXT		'g' /* use COPY .. FROM STDIN .. TEXT to generate data */
+#define INIT_STEP_GEN_TYPE_COPY_BINARY		'c' /* use COPY .. FROM STDIN .. BINARY to generate data */
+/* data init pseudo steps */
+#define INIT_STEP_GEN_TYPE_SINGLE_XACT		'S' /* switch to init data as single transaction */
+#define INIT_STEP_GEN_TYPE_MULTI_XACT		'M' /* switch to init data as multiple transactions */
+
+static bool multi_xact = false;	/* init data type (as single or multiple transactions) */
 static int	nxacts = 0;			/* number of transactions per client */
 static int	duration = 0;		/* duration in seconds */
 static int64 end_time = 0;		/* when to stop in micro seconds, under -T */
@@ -192,7 +194,7 @@ static int	scale = 1;
 /*
  * mode of data generation to use
  */
-static char	data_generation_type = GEN_TYPE_COPY_ORIGINAL;
+static char	data_generation_type = INIT_STEP_GEN_TYPE_COPY_TEXT;
 
 /*
  * COPY FROM BINARY execution buffer
@@ -934,11 +936,13 @@ usage(void)
 		   "                           run selected initialization steps, in the specified order\n"
 		   "                           d: drop any existing pgbench tables\n"
 		   "                           t: create the tables used by the standard pgbench scenario\n"
-		   "                           g: generate data, client-side\n"
-		   "                           C:   client-side (single TNX) COPY .. FROM STDIN .. BINARY\n"
-		   "                           G: generate data, server-side in single transaction\n"
-		   "                           i:   server-side (multiple TXNs) INSERT .. SELECT generate_series\n"
-		   "                           I:   server-side (multiple TXNs) INSERT .. SELECT unnest\n"
+		   "                           to generate data, client-side:\n"
+		   "                             g:   COPY .. FROM STDIN .. TEXT\n"
+		   "                             c:   COPY .. FROM STDIN .. BINARY\n"
+		   "                           to generate data, server-side:\n"
+		   "                             G:   INSERT .. SELECT generate_series\n"
+		   "                             U:   INSERT .. SELECT unnest\n"
+		   "                           M: use multiple transactions to initialize data\n"
 		   "                           v: invoke VACUUM on the standard tables\n"
 		   "                           p: create primary key indexes on the standard tables\n"
 		   "                           f: create foreign keys between the standard tables\n"
@@ -5049,8 +5053,8 @@ initAccount(PQExpBufferData *sql, int64 curr)
 }
 
 static void
-initPopulateTable(PGconn *con, const char *table, int64 base,
-				  initRowMethod init_row)
+initPopulateTableText(PGconn *con, const char *table, int64 base,
+					  initRowMethod init_row)
 {
 	int			n;
 	int64		k;
@@ -5178,6 +5182,9 @@ initGenerateDataClientSideText(PGconn *con)
 {
 	fprintf(stderr, "TEXT mode...\n");
 
+	if (multi_xact)
+		fprintf(stderr, "WARNING! Multiple transactions are not supported in this mode\n");
+
 	/*
 	 * we do all of this in one transaction to enable the backend's
 	 * data-loading optimizations
@@ -5191,9 +5198,9 @@ initGenerateDataClientSideText(PGconn *con)
 	 * fill branches, tellers, accounts in that order in case foreign keys
 	 * already exist
 	 */
-	initPopulateTable(con, "pgbench_branches", nbranches, initBranch);
-	initPopulateTable(con, "pgbench_tellers",  ntellers,  initTeller);
-	initPopulateTable(con, "pgbench_accounts", naccounts, initAccount);
+	initPopulateTableText(con, "pgbench_branches", nbranches, initBranch);
+	initPopulateTableText(con, "pgbench_tellers",  ntellers,  initTeller);
+	initPopulateTableText(con, "pgbench_accounts", naccounts, initAccount);
 
 	executeStatement(con, "commit");
 }
@@ -5450,7 +5457,8 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 	/* Use COPY with FREEZE on v14 and later for all ordinary tables */
 	if ((PQserverVersion(con) >= 140000) &&
 		get_table_relkind(con, table) == RELKIND_RELATION)
-		copy_statement_fmt = "copy %s (%s) from stdin with (format binary)";
+		if (!multi_xact)
+			copy_statement_fmt = "copy %s (%s) from stdin with (format binary, freeze on)";
 
 	n = pg_snprintf(copy_statement, sizeof(copy_statement), copy_statement_fmt, table, columns);
 	if (n >= sizeof(copy_statement))
@@ -5522,11 +5530,13 @@ initGenerateDataClientSideBinary(PGconn *con)
 	/* truncate away any old data */
 	initTruncateTables(con);
 
-	executeStatement(con, "commit");
+	if (multi_xact)
+		executeStatement(con, "commit");
 
 	for (int i = 0; i < scale; i++)
 	{
-		executeStatement(con, "begin");
+		if (multi_xact)
+			executeStatement(con, "begin");
 
 		initPopulateTableBinary(con, "pgbench_branches", "bid, bbalance",
 								i, nbranches, initBranchBinary);
@@ -5535,9 +5545,13 @@ initGenerateDataClientSideBinary(PGconn *con)
 		initPopulateTableBinary(con, "pgbench_accounts", "aid, bid, abalance",
 								i, naccounts, initAccountBinary);
 
-		executeStatement(con, "commit");
+		if (multi_xact)
+			executeStatement(con, "commit");
 	}
 
+	if (!multi_xact)
+		executeStatement(con, "commit");
+
 	pg_free(bin_copy_buffer);
 }
 
@@ -5547,14 +5561,15 @@ initGenerateDataClientSideBinary(PGconn *con)
 static void
 initGenerateDataClientSide(PGconn *con)
 {
-	fprintf(stderr, "generating data (client-side) in ");
+	fprintf(stderr, "generating data (client-side as %s transaction%s) in ",
+			multi_xact ? "multiple" : "single", multi_xact ? "s" : "");
 
 	switch (data_generation_type)
 	{
-		case GEN_TYPE_COPY_ORIGINAL:
+		case INIT_STEP_GEN_TYPE_COPY_TEXT:
 			initGenerateDataClientSideText(con);
 			break;
-		case GEN_TYPE_COPY_BINARY:
+		case INIT_STEP_GEN_TYPE_COPY_BINARY:
 			initGenerateDataClientSideBinary(con);
 			break;
 	}
@@ -5562,58 +5577,7 @@ initGenerateDataClientSide(PGconn *con)
 
 /*
  * Generating data via INSERT .. SELECT .. FROM generate_series
- * whole dataset in single transaction
- */
-static void
-generateDataInsertSingleTXN(PGconn *con)
-{
-	PQExpBufferData sql;
-
-	fprintf(stderr, "via INSERT .. SELECT generate_series... in single TXN\n");
-
-
-	/*
-	 * we do all of this in one transaction to enable the backend's
-	 * data-loading optimizations
-	 */
-	executeStatement(con, "begin");
-
-	/* truncate away any old data */
-	initTruncateTables(con);
-
-	initPQExpBuffer(&sql);
-
-	printfPQExpBuffer(&sql,
-					  "insert into pgbench_branches(bid, bbalance) "
-					  "select bid, 0 "
-					  "from generate_series(1, %d) as bid",
-					  scale * nbranches);
-	executeStatement(con, sql.data);
-
-	printfPQExpBuffer(&sql,
-					  "insert into pgbench_tellers(tid, bid, tbalance) "
-					  "select tid + 1, tid / %d + 1, 0 "
-					  "from generate_series(0, %d) as tid",
-					  ntellers, (scale * ntellers) - 1);
-	executeStatement(con, sql.data);
-
-	printfPQExpBuffer(&sql,
-					  "insert into pgbench_accounts(aid, bid, abalance, "
-								   "filler) "
-					  "select aid + 1, aid / %d + 1, 0, '' "
-					  "from generate_series(0, " INT64_FORMAT ") as aid",
-					  naccounts, (int64) (scale * naccounts) - 1);
-	executeStatement(con, sql.data);
-
-	executeStatement(con, "commit");
-
-	termPQExpBuffer(&sql);
-}
-
-
-/*
- * Generating data via INSERT .. SELECT .. FROM generate_series
- * One transaction per 'scale'
+ * Possibly as "One transaction per scale" in multi-transaction mode
  */
 static void
 generateDataInsertSeries(PGconn *con)
@@ -5629,11 +5593,13 @@ generateDataInsertSeries(PGconn *con)
 	/* truncate away any old data */
 	initTruncateTables(con);
 
-	executeStatement(con, "commit");
+	if (multi_xact)
+		executeStatement(con, "commit");
 
 	for (int i = 0; i < scale; i++)
 	{
-		executeStatement(con, "begin");
+		if (multi_xact)
+			executeStatement(con, "begin");
 
 		printfPQExpBuffer(&sql,
 						  "insert into pgbench_branches(bid, bbalance) "
@@ -5657,15 +5623,19 @@ generateDataInsertSeries(PGconn *con)
 						  (int64) (i + 1) * naccounts - 1);
 		executeStatement(con, sql.data);
 
-		executeStatement(con, "commit");
+		if (multi_xact)
+			executeStatement(con, "commit");
 	}
 
+	if (!multi_xact)
+		executeStatement(con, "commit");
+
 	termPQExpBuffer(&sql);
 }
 
 /*
  * Generating data via INSERT .. SELECT .. FROM unnest
- * One transaction per 'scale'
+ * Possibly as "One transaction per scale" in multi-tansaction mode
  */
 static void
 generateDataInsertUnnest(PGconn *con)
@@ -5681,11 +5651,13 @@ generateDataInsertUnnest(PGconn *con)
 	/* truncate away any old data */
 	initTruncateTables(con);
 
-	executeStatement(con, "commit");
+	if (multi_xact)
+		executeStatement(con, "commit");
 
 	for (int s = 0; s < scale; s++)
 	{
-		executeStatement(con, "begin");
+		if (multi_xact)
+			executeStatement(con, "begin");
 
 		printfPQExpBuffer(&sql,
 						  "insert into pgbench_branches(bid,bbalance) "
@@ -5714,14 +5686,18 @@ generateDataInsertUnnest(PGconn *con)
 						  (int64) (s + 1) * naccounts, naccounts);
 		executeStatement(con, sql.data);
 
-		executeStatement(con, "commit");
+		if (multi_xact)
+			executeStatement(con, "commit");
 	}
 
+	if (!multi_xact)
+		executeStatement(con, "commit");
+
 	termPQExpBuffer(&sql);
 }
 
 /*
- * Fill the standard tables with some data generated on the server
+ * Fill the standard tables with some data generated on the server side
  *
  * As already the case with the client-side data generation, the filler
  * column defaults to NULL in pgbench_branches and pgbench_tellers,
@@ -5730,17 +5706,15 @@ generateDataInsertUnnest(PGconn *con)
 static void
 initGenerateDataServerSide(PGconn *con)
 {
-	fprintf(stderr, "generating data (server-side) ");
+	fprintf(stderr, "generating data (server-side as %s transaction%s) ",
+			multi_xact ? "multiple" : "single", multi_xact ? "s" : "");
 
 	switch (data_generation_type)
 	{
-		case GEN_TYPE_INSERT_ORIGINAL:
-			generateDataInsertSingleTXN(con);
-			break;
-		case GEN_TYPE_INSERT_SERIES:
+		case INIT_STEP_GEN_TYPE_INSERT_SERIES:
 			generateDataInsertSeries(con);
 			break;
-		case GEN_TYPE_INSERT_UNNEST:
+		case INIT_STEP_GEN_TYPE_INSERT_UNNEST:
 			generateDataInsertUnnest(con);
 			break;
 	}
@@ -5845,19 +5819,20 @@ checkInitSteps(const char *initialize_steps)
 
 		switch (*step)
 		{
-			case 'g':
-			case 'C':
-			case 'G':
-			case 'i':
-			case 'I':
+			case INIT_STEP_GEN_TYPE_COPY_TEXT:
+			case INIT_STEP_GEN_TYPE_COPY_BINARY:
+			case INIT_STEP_GEN_TYPE_INSERT_SERIES:
+			case INIT_STEP_GEN_TYPE_INSERT_UNNEST:
 				data_init_type++;
 				data_generation_type = *step;
 				break;
 		}
 	}
 
+	if (data_init_type == 0)
+		pg_log_error("WARNING! No data generation type is provided");
 	if (data_init_type > 1)
-		pg_log_error("WARNING! More than one type of server-side data generation is requested");
+		pg_log_error("WARNING! More than one type of data initialization is requested");
 }
 
 /*
@@ -5895,17 +5870,22 @@ runInitSteps(const char *initialize_steps)
 				op = "create tables";
 				initCreateTables(con);
 				break;
-			case 'g':
-			case 'C':
+			case INIT_STEP_GEN_TYPE_COPY_TEXT:
+			case INIT_STEP_GEN_TYPE_COPY_BINARY:
 				op = "client-side generate";
 				initGenerateDataClientSide(con);
 				break;
-			case 'G':
-			case 'i':
-			case 'I':
+			case INIT_STEP_GEN_TYPE_INSERT_SERIES:
+			case INIT_STEP_GEN_TYPE_INSERT_UNNEST:
 				op = "server-side generate";
 				initGenerateDataServerSide(con);
 				break;
+			case INIT_STEP_GEN_TYPE_SINGLE_XACT:
+				multi_xact = false;
+				break;
+			case INIT_STEP_GEN_TYPE_MULTI_XACT:
+				multi_xact = true;
+				break;
 			case 'v':
 				op = "vacuum";
 				initVacuum(con);
diff --git a/src/bin/pgbench/t/001_pgbench_with_server.pl b/src/bin/pgbench/t/001_pgbench_with_server.pl
index a377048ead1..acb1e31d3e8 100644
--- a/src/bin/pgbench/t/001_pgbench_with_server.pl
+++ b/src/bin/pgbench/t/001_pgbench_with_server.pl
@@ -117,6 +117,7 @@ $node->pgbench(
 	[qr{Perhaps you need to do initialization}],
 	'run without init');
 
+
 # Initialize pgbench tables scale 1
 $node->pgbench(
 	'-i', 0,
@@ -160,7 +161,7 @@ $node->pgbench(
 		qr{creating tables},
 		qr{creating 3 partitions},
 		qr{creating primary keys},
-		qr{generating data \(server-side\)},
+		qr{generating data \(server-side as single transaction\)},
 		qr{creating foreign keys},
 		qr{(?!vacuuming)},    # no vacuum
 		qr{done in \d+\.\d\d s }
@@ -170,15 +171,16 @@ $node->pgbench(
 # Check data state, after server-side data generation.
 check_data_state($node, 'server-side');
 
+
 # Test server-side generation with UNNEST
 $node->pgbench(
-	'--initialize --init-steps=dtI',
+	'--initialize --init-steps=dtU',
 	0,
 	[qr{^$}],
 	[
 		qr{dropping old tables},
 		qr{creating tables},
-		qr{generating data \(server-side\)},
+		qr{generating data \(server-side as single transaction\)},
 		qr{done in \d+\.\d\d s }
 	],
 	'pgbench --init-steps server-side UNNEST');
@@ -186,15 +188,48 @@ $node->pgbench(
 # Check data state, after server-side data generation.
 check_data_state($node, 'server-side (unnest)');
 
-# Test server-side generation with UNNEST
+
+# Test server-side generation with COPY TEXT
+$node->pgbench(
+	'--initialize --init-steps=dtg',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(client-side as single transaction},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps client-side TEXT');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'client-side (text)');
+
+$node->pgbench(
+	'--initialize --init-steps=dtMg',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(client-side as multiple transactions},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps client-side TEXT');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'client-side (text)');
+
+
+# Test server-side generation with COPY BINARY
 $node->pgbench(
-	'--initialize --init-steps=dtC',
+	'--initialize --init-steps=dtc',
 	0,
 	[qr{^$}],
 	[
 		qr{dropping old tables},
 		qr{creating tables},
-		qr{generating data \(client-side\)},
+		qr{generating data \(client-side as single transaction},
 		qr{done in \d+\.\d\d s }
 	],
 	'pgbench --init-steps client-side BINARY');
@@ -202,6 +237,52 @@ $node->pgbench(
 # Check data state, after server-side data generation.
 check_data_state($node, 'client-side (binary)');
 
+$node->pgbench(
+	'--initialize --init-steps=dtSc',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(client-side as single transaction},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps client-side BINARY');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'client-side (binary)');
+
+$node->pgbench(
+	'--initialize --init-steps=dtMc',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(client-side as multiple transactions},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps client-side BINARY');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'client-side (binary)');
+
+$node->pgbench(
+	'--initialize --init-steps=dtMc',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(client-side as multiple transactions},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps client-side BINARY');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'client-side (binary)');
+
+
 # Run all builtin scripts, for a few transactions each
 $node->pgbench(
 	'--transactions=5 -Dfoo=bla --client=2 --protocol=simple --builtin=t'
-- 
2.43.0

